.486
.model flat, stdcall
option casemap: none

; API functions
; ------------------------------------------------------------------------------
include  \masm32\include\windows.inc
include  \masm32\include\user32.inc
include  \masm32\include\kernel32.inc
include  \masm32\include\comctl32.inc
include  \masm32\include\masm32.inc
include  \masm32\include\gdi32.inc 
include  \masm32\include\shell32.inc


includelib  \masm32\lib\user32.lib
includelib  \masm32\lib\kernel32.lib
includelib  \masm32\lib\comctl32.lib
includelib  \masm32\lib\masm32.lib
includelib  \masm32\lib\gdi32.lib 
includelib  \masm32\lib\shell32.lib
include 	\masm32\include\msimg32.inc
includelib 	\masm32\lib\msimg32.lib
; ------------------------------------------------------------------------------

; Prototype 
; ------------------------------------------------------------------------------
DialogProc PROTO : HWND, : UINT, : WPARAM, : LPARAM

.const

; Resource ids
; ------------------------------------------------------------------------------
IDD_DLG1  	  equ 101
IDI_ICON      equ 200
IDC_BTN1      equ 103
IDC_SHP1      equ 104
IDC_SHP2      equ 105

; Required data

.data

.data?

hInstance HINSTANCE ?
hIcon     HICON     ?
ResInf			dd		?
ResDat			dd		?
ResSize	    	dd		?
SHPRes			dd		?
Brush			dd		?
.code

start:
INVOKE GetModuleHandle, NULL
mov hInstance, eax

INVOKE LoadIcon, eax, IDI_ICON 
mov hIcon, eax
INVOKE InitCommonControls
; ---------------------------------------------
;   Call the dialog box stored in resource file
; ---------------------------------------------
INVOKE DialogBoxParam, hInstance, IDD_DLG1 , NULL, ADDR DialogProc, 0
INVOKE ExitProcess, 0


; Dialog procedure
; ------------------------------------------------------------------------------
DialogProc proc uses ebx esi edi hWnd: HWND, uMsg: UINT, wParam: WPARAM, lParam: LPARAM

LOCAL rect:RECT
LOCAL ps:PAINTSTRUCT
LOCAL hdc:HDC
LOCAL nx:DWORD
LOCAL ny:DWORD
LOCAL pt:POINT
LOCAL _size:_SIZE

mov	eax, uMsg
 .IF eax == WM_INITDIALOG
  invoke GetWindowLong,hWnd,GWL_EXSTYLE 
	
	invoke SetWindowLong,hWnd,GWL_EXSTYLE,eax 
	invoke SetWindowPos,hWnd,HWND_TOPMOST,0,0,0,0,SWP_NOMOVE+SWP_NOSIZE
     
	invoke CreatePatternBrush,eax
	mov Brush,eax
	invoke FindResource,hInstance,hWnd,104
	mov ResInf,eax
	invoke LoadResource,hInstance,ResInf
	mov ResDat,eax
	invoke SizeofResource,hInstance,ResInf
	mov	ResSize,eax
	invoke LockResource,ResDat
	mov SHPRes,eax
	invoke ExtCreateRegion,104,ResSize,SHPRes
	invoke SetWindowRgn,hWnd,eax,TRUE
	
	invoke SendMessage,hWnd,WM_SETICON,1,eax
	
	
	invoke ShowWindow,hWnd,SW_SHOW
	

  .ELSEIF eax  == WM_LBUTTONDOWN
    INVOKE SendMessage, hWnd, WM_NCLBUTTONDOWN,HTCAPTION, 0

    .ELSEIF uMsg == WM_COMMAND
    
   
		
     .IF wParam == IDC_BTN1
      INVOKE SendMessage, hWnd, WM_CLOSE, 0, 0
    .ENDIF
	
      .ELSEIF uMsg == WM_CLOSE
    INVOKE EndDialog, hWnd, 0
 .ENDIF
 

    xor eax,eax
  ret
DialogProc endp

end start